#https://github.com/ateucher/useful_code/blob/master/R/numbers2words.r
  numbers2words <- function(x, ordinal=FALSE){
    ## Function by John Fox found here: 
    ## http://tolstoy.newcastle.edu.au/R/help/05/04/2715.html
    ## Tweaks by AJH to add commas and "and"
    ## More tweaks by Christopher Adolph to add ordinal support  
    ##  ***still needs work for ordinal numbers >99
      helper <- function(x, ordinal=FALSE){
      
        digits <- rev(strsplit(as.character(x), "")[[1]])
        nDigits <- length(digits)
        if (nDigits == 1) {
            as.vector(ones[digits])
        } else {
            if (nDigits == 2) {
                if (x <= 19) {
                    as.vector(teens[digits[1]])
                } else {
                    if (x%%10==0) {
                        trim(paste(tens[digits[2]]))
                    } else {
                        trim(paste(tens0[digits[2]],
                                   Recall(as.numeric(digits[1]))))
                    }
                }
            } else {
                if (nDigits == 3) {
                    if (ordinal&&(x%%100==0)) {
                        trim(paste(ones0[digits[3]], "hundredth"))
                    } else {
                        trim(paste(ones0[digits[3]], "hundred and", 
                                   Recall(makeNumber(digits[2:1]))))
                    }
                } else {
                    nSuffix <- ((nDigits + 2) %/% 3) - 1
                    if (nSuffix > length(suffixes)) stop(paste(x, "is too large!"))
                    trim(paste(Recall(makeNumber(digits[nDigits:(3*nSuffix + 1)], ordinal=FALSE), ordinal=FALSE),
                               suffixes[nSuffix],"," ,
                               Recall(makeNumber(digits[(3*nSuffix):1]))),
                         ordinal)
                }
            }
        }
    }
    trim <- function(text, ordinal=FALSE){
      #Tidy leading/trailing whitespace, space before comma
      text <- gsub("^\ ", "", gsub("\ *$", "", gsub("\ ,",",",text)))
      #Clear any trailing " and"
      text <- gsub(" and$","",text)
      #Clear any trailing comma
      text <- gsub("\ *,$","",text)
      #Add th to thousandth, millionth, etc.
      if (ordinal) {text <- gsub("sand$", "sandth", text)
                    text <- gsub("lion$", "lionth", text)}
      text
    }  
    makeNumber <- function(..., ordinal=FALSE) as.numeric(paste(..., collapse=""))     
    #Disable scientific notation
    opts <- options(scipen=100) 
    on.exit(options(opts))
    ones0 <- c("", "one", "two", "three", "four", "five", "six", "seven",
               "eight", "nine")
    names(ones0) <- 0:9
    teens0 <- c("ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen",
                   "sixteen", " seventeen", "eighteen", "nineteen")
    names(teens0) <- 0:9
    tens0 <- c("twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty",
              "ninety") 
    names(tens0) <- 2:9 
    if (ordinal) {
        ones <- c("", "first", "second", "third", "fourth", "fifth", "sixth", "seventh",
                  "eighth", "ninth")
    } else {
        ones <- c("", "one", "two", "three", "four", "five", "six", "seven",
                  "eight", "nine")
    }
    names(ones) <- 0:9
    if (ordinal) {
        teens <- c("tenth", "eleventh", "twelfth", "thirteenth", "fourteenth", "fifteenth",
                   "sixteenth", " seventeenth", "eighteenth", "nineteenth")
    } else {
        teens <- c("ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen",
                   "sixteen", " seventeen", "eighteen", "nineteen")
    }
    names(teens) <- 0:9
    if (ordinal) {
        tens <- c("twentieth", "thirtieth", "fortieth", "fiftieth", "sixtieth", "seventieth", "eightieth",
                  "ninetieth")
    } else {
        tens <- c("twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty",
                  "ninety")
    }
    names(tens) <- 2:9 
    x <- round(x)
    suffixes <- c("thousand", "million", "billion", "trillion")     
    if (length(x) > 1) return(trim(sapply(x, helper, ordinal=ordinal)))
    helper(x, ordinal)
  }
